<?php
namespace Ecommerce\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ContasAReceberRelatorio extends \Zeedhi\Framework\Controller\Report {
    protected $reportService;
    protected $birtStrategy;
    protected $environment;
    protected $QR2Strategy;
    protected $connection;
    protected $repParam;
    
    
    public function __construct($reportService, $birtStrategy, $environment, $QR2Strategy, $connection) {
        $this->reportService     = $reportService;
        $this->birtStrategy      = $birtStrategy;
        $this->environment       = $environment;
        $this->QR2Strategy       = $QR2Strategy;
        $this->connection        = $connection;
        
        $this->repParam = array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                  'P_CDFORNECED'    => 'P_CDFORNECED',
                  'P_TDTVENC'       => 'P_TDTVENC',
                  'P_DTINICIAL'     => 'P_DTINICIAL',
                  'P_DTFINAL'       => 'P_DTFINAL',
                  'P_TDTPAGA'       => 'P_TDTPAGA',
                  'P_DTPAGINI'      => 'P_DTPAGINI',
                  'P_DTPAGFIN'      => 'P_DTPAGFIN',
                  'NF'              => 'NF',
                  'CDEMPRESA'       => 'CDEMPRESA',
                  'STATUS'          => 'STATUS',
                  'P_DSLOGINECO'    => 'P_DSLOGINECO',
                  'ANTECIPADA'      => 'ANTECIPADA'
                )
              );

        $this->reportMapping = array (
            'ECO00100' => $this->repParam,
            'ECO00101' => $this->repParam
        );
    }
    
     protected $reportMapping = array (
      'ECO00100' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          'P_CDFORNECED'    => 'P_CDFORNECED',
          'P_TDTVENC'       => 'P_TDTVENC',
          'P_DTINICIAL'     => 'P_DTINICIAL',
          'P_DTFINAL'       => 'P_DTFINAL',
          'P_TDTPAGA'       => 'P_TDTPAGA',
          'P_DTPAGINI'      => 'P_DTPAGINI',
          'P_DTPAGFIN'      => 'P_DTPAGFIN',
          'NF'              => 'NF',
          'CDEMPRESA'       => 'CDEMPRESA',
          'STATUS'          => 'STATUS',
          'P_DSLOGINECO'    => 'P_DSLOGINECO',
          'ANTECIPADA'      => 'ANTECIPADA'
        )
      )
  );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
    
}